package com.huimv.admin.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @Description: 注册验证tocken的拦截器
 * @Author
 * @Date 2021/4/19 20:41
 * @Version V1.0
 */
@Configuration
public class InterceptorConfig implements WebMvcConfigurer {
    @Bean
    public JWTInterceptor jwtInterceptor(){
        return new JWTInterceptor();
    }

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        registry.addInterceptor(jwtInterceptor()).
                excludePathPatterns("/huatongApi/admin/my/*","/huatongApi/env-nh3-n/send")
                .excludePathPatterns("/huatongApi/receive/feed","/huatongApi/energy-data/getData"
                        ,"/huatongApi/energy-data/getData2" ,"/huatongApi/energy-data/getData3","/huatongApi/energy-data/getData4"
                        ,"/huatongApi/energy-data/getData5"
                        ,"/huatongApi/energy-data/getData6"
                        ,"/huatongApi/energy-data/getData7"
                        ,"/huatongApi/energy-data/getData8");
    }
}
